import { __rest } from 'tslib';
import '@puzzlelabs/puzzle-glossary';
import { useRef, useState, useEffect, createElement } from 'react';

const HighlightZone = (_a) => {
    var { as = 'span' } = _a, props = __rest(_a, ["as"]);
    const ref = useRef();
    const [manager, setManager] = useState(window.highlightWidgetManager);
    useEffect(() => {
        if (manager) {
            return;
        }
        const listener = () => {
            setManager(window.highlightWidgetManager);
        };
        document.addEventListener('highlightWidgetReady', listener);
        return () => document.removeEventListener('highlightWidgetReady', listener);
    }, []);
    useEffect(() => {
        if (!manager) {
            return;
        }
        return manager.subscribe(() => {
            if (!manager.ready) {
                return;
            }
            manager.mark([ref.current]);
        });
    }, [manager]);
    return createElement(as, Object.assign(Object.assign({}, props), { ref }));
};

export { HighlightZone };
