'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const tslib = require('tslib');
require('@puzzlelabs/puzzle-glossary');
const react = require('react');

const HighlightZone = (_a) => {
    var { as = 'span' } = _a, props = tslib.__rest(_a, ["as"]);
    const ref = react.useRef();
    const [manager, setManager] = react.useState(window.highlightWidgetManager);
    react.useEffect(() => {
        if (manager) {
            return;
        }
        const listener = () => {
            setManager(window.highlightWidgetManager);
        };
        document.addEventListener('highlightWidgetReady', listener);
        return () => document.removeEventListener('highlightWidgetReady', listener);
    }, []);
    react.useEffect(() => {
        if (!manager) {
            return;
        }
        return manager.subscribe(() => {
            if (!manager.ready) {
                return;
            }
            manager.mark([ref.current]);
        });
    }, [manager]);
    return react.createElement(as, Object.assign(Object.assign({}, props), { ref }));
};

exports.HighlightZone = HighlightZone;
